/*
    Copyright (c) 1991, 1992 by NeXT Computer, Inc as an unpublished work.
    All rights reserved.
*/
#import <appkit/NXImageRep.h>
#import <streams/streams.h>
#import <ri/ri.h>
#import "next3d.h"

@interface N3DRIBImageRep : NXImageRep
{
  N3DHider hider;
  N3DSurfaceType surface;
  NXColor backgroundColor;
  char *_data;
  int	_dlen;
  NXRect _RIBbbox, _printbbox;
  float _aspect_ratio;
  RtToken _imageToken;
  int _lastWindowNum;
  char *_spoolfile;
  void *_N3Dprivate;
}

+ (const char *const *)imageUnfilteredFileTypes;
+ (const NXAtom *)imageUnfilteredPasteboardTypes;
+ (BOOL)canLoadFromStream:(NXStream *)ribstream;
- initFromFile:(const char *)ribfile;
- initFromStream:(NXStream *)ribstream;
- free;
- (BOOL)drawIn:(const NXRect *)rect;
- (BOOL)drawAt:(const NXPoint *)point;
- (BOOL)draw;
- getSize:(NXSize *)theSize;
- getBoundingBox:(NXRect *)r;
- setSurfaceType:(N3DSurfaceType)surfaceType;
- setHider:(N3DHider)ahider;
- (N3DSurfaceType)surfaceType;
- (N3DHider)hider;
- setBackgroundColor:(NXColor)col;
- (NXColor)backgroundColor;


- read:(NXTypedStream *)stream;
- write:(NXTypedStream *)stream;

@end
