/*
**      DBAssociation.h
**      Database Kit, Release 3.0
**      Copyright (c) 1992, NeXT Computer, Inc.  All rights reserved. 
*/

/*
** DBAssociation represents an association between an expression in the
** DBModule and an object, usually a UI object. In the generic case,
** the DBModule will automatically map data back and forth between the UI
** object and the DBRecordList.
**
** DBAssociations are the run-time instantiation of connections.
*/

#import <objc/Object.h>

@class DBValue;

@interface DBAssociation : Object {
    id		_destination;
    id		_fetchGroup;
    id		_expression;
}

- initFetchGroup:aFetchGroup expression:anExpr destination:theDestination;
- setDestination:newDestination;
- destination;
- fetchGroup;
- expression;

/* notification and control methods sent from DBFetchGroup to associations */
- contentsDidChange;
- selectionDidChange;
- currentRecordDidDelete;
- setValue:value;
- getValue:value;
- validateEditing;
- endEditing;
- (unsigned)selectedRowAfter:(unsigned)previousRow;
@end


/* notifications sent to destination of custom associations */
@interface Object(DBCustomAssociation)
- associationContentsDidChange:association;
- associationSelectionDidChange:association;
- associationCurrentRecordDidDelete:association;
- association:association setValue:(DBValue *)value;
-$	Wociation:association getValue:(DBValue *)value;
@end

