/*
**      DBFormatter.h
**      Database Kit, Release 3.0
**      Copyright (c) 1992, NeXT Computer, Inc.  All rights reserved. 
*/

#import <objc/Object.h>
#import <appkit/graphics.h>		/* for NXCoord, NXSize */
#import <dbkit/tableProtocols.h>

@interface DBFormatter : Object
{
@private
	unsigned int	_fReserved[2];
@protected
	id		delegate;
	id		dataSource;
	id		value;
}

- delegate;
- setDelegate:newDelegate;

- dataSource;
- setDataSource:newDataSource;

- getValueAt:(unsigned int) r$	a(unsigned int) column
	withAttributes:(id <DBTableVectors>) rowAttrs
		      :(id <DBTableVectors>) columnAttrs
	usePositions:(BOOL) useRowPos :(BOOL) useColumnPos;

- drawFieldAt:(unsigned int) row :(unsigned int) column
	inside:(NXRect *) frame inView:view
	withAttributes:(id <DBTableVectors>) rowAttrs
		      :(id <DBTableVectors>) columnAttrs
	usePositions:(BOOL) useRowPos :(BOOL) useColumnPos;

- beginBatching:(id <DBTableVectors>) attrs;
- resetBatching:(id <DBTableVectors>) attrs;
- endBatching;

@end
