#
#                                 subproj.make
#
# Inputs from Makefile.preamble or Makefile.postamble (no defaults):
#	OTHER_CFLAGS - Flags passed to compiler (in addition to -g, -O, etc.)
#	OTHER_LDFLAGS - Flags passed to ld (in addition to -ObjC, etc.)
#	OTHER_OFILES - Additional relocatables that may be linked in
#	OTHER_PRODUCT_DEPENDS - Other dependencies of this project
#	OTHER_SOURCEFILES - Other source files maintained by .pre/postamble
#	OTHER_GARBAGE - Additional files to be removed by make 'clean' 
#
# Inputs from Makefile.preamble (no defaults):
#	PRECOMPS - Precompiled headers that should be built before compilation 
#	OTHER_INITIAL_TARGETS - Targets to be built before subprojects, etc.
#
# Inputs from Makefile.postamble (with defaults set in common.make):
#	MAKEFILES - Makefiles this project depends on (default = Makefile)
#
# Inputs from Makefile (avoid setting these, ProjectBuilder controls them):
#	NAME - name of application
#	LANGUAGE - langage in which the project is written (default "English")
#	LOCAL_RESOURCES - localized resources (e.g. nib's, images) of project
#	GLOBAL_RESOURCES - non-localized resources of project
#
#	CLASSES - Class implementation files in project.
#	HFILES - Header files in project.
#	MFILES - Other Objective-C source files in project. 
#	CFILES - Other C source files in project. 
#	PSWFI3- .psw files in the project
#	PSWMFILES - .pswm files in the project
#	SUBPROJECTS - Subprojects of this project
#	BUNDLES - Bundle subprojects of this project
#	OTHERSRCS - Other miscellaneous sources of this project
#	OTHERLINKED - Source files not matching a standard source extention
#	OTHERLINKEDOFILES - Other relocatable files to (always) link in.
#	MAKEFILEDIR - Directory in which to find this generic set of Makefiles
#

include $(MAKEFILEDIR)/common.make

DOTO = $(OFILE_DIR)/$(NAME:.subproj=.o)

project:: $(INITIAL_TARGETS) subcomponents resources $(DOTO)

$(DOTO): $(PRODUCT_DEPENDS)
	@($(MKDIRS) $(OFILE_DIR) ; \
	if [ "`$(ECHO) $(OFILES) | wc -w`" != "       0" ] ; then \
	   $(ECHO) $(LD) $(OFILES) -r -o $(DOTO) ; \
	   $(LD) $(OFILES) -r -o $(DOTO) ; \
	else \
	   $(ECHO) Warning: Building empty subproject... ; \
	   $(TOUCH) $(NAME:.subproj=.c) ; \
	   $(CC) $(CFLAGS) $(OTHER_CFLAGS) -c $(NAME:.subproj=.c) -o $(DOTO) ; \
	   $(RM) $(NAME:.subproj=.c) ; \
	fi)

depend:: Makefile.dependencies $(SUBPROJECTS:.subproj=.depend) $(BUNDLES:.bproj=.depend)
